/*
	Password Prompter - PC Magazine password utility

	Copyright (c) 1999 Ziff-Davis Publishing Company.  All rights reserved.
	First published in PC Magazine, US Edition  June 8, 1999.

	Written by Steven E. Sipe


	This file implements the change password dialog
*/

#include "stdafx.h"
#include "passprom.h"
#include "ChgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPChgPassDlg dialog


CPPChgPassDlg::CPPChgPassDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPPChgPassDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPPChgPassDlg)
	m_Confirm = _T("");
	m_Password = _T("");
	//}}AFX_DATA_INIT
}


void CPPChgPassDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPChgPassDlg)
	DDX_Text(pDX, IDC_CONFIRM, m_Confirm);
	DDV_MaxChars(pDX, m_Confirm, 20);
	DDX_Text(pDX, IDC_PASSWORD, m_Password);
	DDV_MaxChars(pDX, m_Password, 20);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPPChgPassDlg, CDialog)
	//{{AFX_MSG_MAP(CPPChgPassDlg)
	ON_BN_CLICKED(IDC_HELPBTN, OnHelpBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPChgPassDlg message handlers

// Handles the OK button
void CPPChgPassDlg::OnOK() 
{
	UpdateData(TRUE);

	// Get the new password and confirm password.  Trim trailing spaces
	m_Confirm.TrimRight();
	m_Password.TrimRight();

	// If they don't match, yell at the user
	if(m_Confirm != m_Password)
	{
		AfxMessageBox(IDS_BAD_CONFIRM,MB_ICONWARNING|MB_OK);
		return;
	}

	CDialog::OnOK();
}

// Handles Help button
void CPPChgPassDlg::OnHelpBtn() 
{
	AfxGetApp()->WinHelp(103,HELP_CONTEXT);
}
