/*
	Password Prompter - PC Magazine password utility

	Copyright (c) 1999 Ziff-Davis Publishing Company.  All rights reserved.
	First published in PC Magazine, US Edition  June 8, 1999.

	Written by Steven E. Sipe


	This file implements the login screen.
*/

#include "stdafx.h"
#include "passprom.h"
#include "Login.h"
#include "database.h"
#include "chgdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPLogin dialog


CPPLogin::CPPLogin(CWnd* pParent /*=NULL*/)
	: CDialog(CPPLogin::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPPLogin)
	m_Password = _T("");
	//}}AFX_DATA_INIT
}


void CPPLogin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPLogin)
	DDX_Text(pDX, IDC_PASSWORD, m_Password);
	DDV_MaxChars(pDX, m_Password, 20);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPPLogin, CDialog)
	//{{AFX_MSG_MAP(CPPLogin)
	ON_BN_CLICKED(IDC_CHANGE, OnChange)
	ON_BN_CLICKED(IDC_HELPBTN, OnHelpBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPLogin message handlers

// Returns TRUE if the user entered password is correct
BOOL CPPLogin::PasswordOK()
{
	CString strCurrPassword;

	// Get the current password and entered password
	UpdateData(TRUE);
	m_Password.TrimRight();
	m_pDatabase->SetPassword(m_Password,FALSE);

	BOOL bRet = m_pDatabase->Load();

	if(!bRet)
	{
		AfxMessageBox(IDS_LOAD_ERROR,MB_ICONWARNING|MB_OK);
		return(TRUE);
	}

	return(m_pDatabase->IsValid());
}

// Handles the OK button
void CPPLogin::OnOK() 
{
	// Is the password valid
	if(!PasswordOK())
	{
		AfxMessageBox(IDS_BAD_PASSWORD,MB_ICONWARNING|MB_OK);
		return;
	}

	CDialog::OnOK();
}

// Handles the Change button
void CPPLogin::OnChange() 
{
	// Is the password valid
	if(!PasswordOK())
	{
		AfxMessageBox(IDS_VALID_FIRST,MB_ICONWARNING|MB_OK);
		return;
	}

	CPPChgPassDlg dlgChange;

	// Allow the user to change the password
	if(dlgChange.DoModal() == IDOK)
	{
		CString strNewPassword;

		// Get the new password and save it in the database
		strNewPassword = dlgChange.GetNewPassword();
		m_pDatabase->SetPassword(strNewPassword);
		m_pDatabase->Save();

		// Also update the screen's password field
		m_Password = strNewPassword;
		UpdateData(FALSE);
	}
}

// Handles the Help button
void CPPLogin::OnHelpBtn() 
{
	AfxGetApp()->WinHelp(102,HELP_CONTEXT);
}
