/*
	Password Prompter - PC Magazine password utility

	Copyright (c) 1999 Ziff-Davis Publishing Company.  All rights reserved.
	First published in PC Magazine, US Edition  June 8, 1999.

	Written by Steven E. Sipe


	This file implements the main dialog class.
*/

#include "stdafx.h"
#include "passprom.h"
#include "MainDlg.h"
#include "passdlg.h"
#include "login.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CenterWindow();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CPPDlg dialog

CPPDlg::CPPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPPDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPPDlg)
	m_Comments = _T("");
	m_Hint = _T("");
	m_URL = _T("");
	m_UserName = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_bIsNew = FALSE;
	m_bDirty = FALSE;

	m_strFileName = "ppinfo.dat";
}

void CPPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPDlg)
	DDX_Control(pDX, IDC_DESCRIPTION, m_Description);
	DDX_Control(pDX, IDC_PASSGEN, m_PassGen);
	DDX_Control(pDX, IDC_PASSWORD, m_Password);
	DDX_Control(pDX, IDC_LAUNCH, m_Launch);
	DDX_Control(pDX, IDC_WRITE, m_Write);
	DDX_Control(pDX, IDC_LOCK, m_Lock);
	DDX_Control(pDX, IDC_CARD, m_Card);
	DDX_Text(pDX, IDC_COMMENTS, m_Comments);
	DDV_MaxChars(pDX, m_Comments, 200);
	DDX_Text(pDX, IDC_HINT, m_Hint);
	DDV_MaxChars(pDX, m_Hint, 100);
	DDX_Text(pDX, IDC_URL, m_URL);
	DDV_MaxChars(pDX, m_URL, 200);
	DDX_Text(pDX, IDC_USERNAME, m_UserName);
	DDV_MaxChars(pDX, m_UserName, 100);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPPDlg, CDialog)
	//{{AFX_MSG_MAP(CPPDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LAUNCH, OnLaunch)
	ON_BN_CLICKED(IDC_PASSGEN, OnPasswordGenerate)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_BN_CLICKED(IDC_NEW, OnNew)
	ON_BN_CLICKED(IDC_CANCEL, OnCancelBtn)
	ON_CBN_SELENDOK(IDC_DESCRIPTION, OnSelendOkDescription)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_HELPBTN, OnHelpBtn)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	//}}AFX_MSG_MAP
	ON_CBN_EDITCHANGE(IDC_DESCRIPTION, OnChangeFields)
	ON_EN_CHANGE(IDC_URL, OnChangeFields)
	ON_EN_CHANGE(IDC_DESCRIPTION, OnChangeFields)
	ON_EN_CHANGE(IDC_USERNAME, OnChangeFields)
	ON_EN_CHANGE(IDC_PASSWORD, OnChangeFields)
	ON_EN_CHANGE(IDC_HINT, OnChangeFields)
	ON_EN_CHANGE(IDC_COMMENTS, OnChangeFields)
	ON_MESSAGE(UM_RESET,OnReset)
	ON_MESSAGE(UM_LOGIN,OnLogin)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPDlg message handlers

// Initializes the display fields
BOOL CPPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CRect rc;

	// Set the screen location
	rc.left = AfxGetApp()->GetProfileInt("Location","X",-1);
	rc.top = AfxGetApp()->GetProfileInt("Location","Y",-1);

	if(rc.left == -1 && rc.top == -1)
		CenterWindow();
	else SetWindowPos(NULL,rc.left,rc.top,-1,-1,SWP_NOSIZE);

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}

		// Disable the Size and Maximize options since our app 
		// doesn't allow this capability
		pSysMenu->EnableMenuItem(2,MF_DISABLED|MF_GRAYED|MF_BYPOSITION);
		pSysMenu->EnableMenuItem(4,MF_DISABLED|MF_GRAYED|MF_BYPOSITION);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Set the database name to use
	m_Database.SetFileName(m_strFileName);
	
	// Set the image backgrounds
	COLORMAP mapColor[1];
	HBITMAP hBitmap;

	// Map MAGENTA in the logo to the proper background color
	mapColor[0].from = RGB(255,0,255);
	mapColor[0].to  = ::GetSysColor(COLOR_BTNFACE);

	// Set Card bitmap
	hBitmap = (HBITMAP)::CreateMappedBitmap(AfxGetApp()->m_hInstance,
							IDB_CARD,0,mapColor,1);
	m_Card.SetBitmap(hBitmap);

	// Set Lock bitmap
	hBitmap = (HBITMAP)::CreateMappedBitmap(AfxGetApp()->m_hInstance,
							IDB_LOCK,0,mapColor,1);
	m_Lock.SetBitmap(hBitmap);

	// Set Write bitmap
	hBitmap = (HBITMAP)::CreateMappedBitmap(AfxGetApp()->m_hInstance,
							IDB_WRITE,0,mapColor,1);
	m_Write.SetBitmap(hBitmap);

	// Set Launch bitmap
	hBitmap = (HBITMAP)::CreateMappedBitmap(AfxGetApp()->m_hInstance,
							IDB_LAUNCH,0,mapColor,1);
	m_Launch.SetBitmap(hBitmap);

	// Set Password Generation bitmap
	hBitmap = (HBITMAP)::CreateMappedBitmap(AfxGetApp()->m_hInstance,
							IDB_GENERATE,0,mapColor,1);
	m_PassGen.SetBitmap(hBitmap);

	// Set some field size limits
	m_Description.LimitText(100);
	m_Password.LimitText(100);
	m_Launch.EnableWindow(FALSE);

	// Create tooltip
	m_ToolTip.Create(this);  

	// Add buttons to tooltip
	m_ToolTip.AddTool(&m_PassGen,"Generate Random Password"); 
	m_ToolTip.AddTool(&m_Launch,"Launch URL"); 

	// Activate tooltip
	m_ToolTip.Activate(TRUE); 	

	// Setup to display the login screen
	PostMessage(UM_LOGIN);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPPDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CPPDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPPDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//
// Button handlers
//

// Launches the URL specified in the URL field
void CPPDlg::OnLaunch() 
{
	UpdateData(TRUE);

	if(m_URL.GetLength() > 0)
	{
		CString strParams, strURL = m_URL;

		if(strURL.Left(7).CompareNoCase("http://") != 0)
		{
			// Make sure filename isn't quoted before arguments
			int nStartQuote = strURL.Find("\"",0);
			int nEndQuote = 0;

			if(nStartQuote >= 0)
			{
				nEndQuote = strURL.Find("\"",nStartQuote+1);
				if(nEndQuote)
				{
					strParams = strURL.Mid(nEndQuote+1);
					strURL = strURL.Mid(nStartQuote+1,nEndQuote-1);
				}
			}
			else
			{
				int nBlank;

				nBlank = strURL.Find(" ",0);

				if(nBlank > 0)
				{
					strParams = strURL.Mid(nBlank+1);
					strURL = strURL.Left(nBlank);
				}
			}
		}
		else strParams.Empty();

		ShellExecute(NULL,"open",strURL,strParams,NULL,SW_SHOWNORMAL);
	}
}

// Sets the dirty flag and enables the launch button any time the
// field contents change
void CPPDlg::OnChangeFields() 
{
	if(!m_strOrigDescription.IsEmpty() || m_bIsNew)
	{
		UpdateData(TRUE);

		// Enable lauch button if URL specified
		m_Launch.EnableWindow(m_URL.GetLength() > 0);

		// Initialize Cancel and New buttons based on the entry type
		GetDlgItem(IDC_CANCEL)->EnableWindow(TRUE);
		GetDlgItem(IDC_DELETE)->EnableWindow(!m_bIsNew);

		// Set the description text
		CString strText;
		m_Description.GetWindowText(strText);
		strText.TrimRight();
		GetDlgItem(IDC_SAVE)->EnableWindow(!strText.IsEmpty());

		// Set dirty flag so we can prompt user to save entry
		m_bDirty = TRUE;
	}
}

// Handles the Generate button to generate a random password
void CPPDlg::OnPasswordGenerate() 
{
	CPPGenPassDlg dlgPass;

	if(dlgPass.DoModal() == IDOK)
		m_Password.SetWindowText(dlgPass.GetPassword());
}

// Displays the about screen
void CPPDlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

// Handles adding a new entry
void CPPDlg::OnNew() 
{
	if(SavePrompt() == IDCANCEL)
		return;

	LoadFields(TRUE);
	EnableFields(TRUE);

	GetDlgItem(IDC_SAVE)->EnableWindow(FALSE);
	GetDlgItem(IDC_DELETE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CANCEL)->EnableWindow(TRUE);

	m_bIsNew = TRUE;
	m_bDirty = FALSE;

	m_Description.SetFocus();
	m_strOrigDescription = "";
}

// Handles Save button
void CPPDlg::OnSave() 
{
	Save();
}

// Saves the current entry
BOOL CPPDlg::Save(BOOL bReselect)
{
	CString strDescription, strPassword;
	BOOL bRet;

	UpdateData(TRUE);

	m_Description.GetWindowText(strDescription);
	strDescription.TrimRight();

	// Blank descriptions won't be saved so just get out now
	if(strDescription.IsEmpty())
	{
		AfxMessageBox(IDS_BLANK_DESCRIPTION,MB_ICONWARNING|MB_OK);
		return(FALSE);
	}

	m_Password.GetWindowText(strPassword);

	// Add or modify the entry record
	if(m_bIsNew)
		bRet = m_Database.Add(strDescription,m_UserName,strPassword,m_Hint,m_Comments,m_URL);
	else bRet = m_Database.Modify(m_strOrigDescription,strDescription,m_UserName,strPassword,m_Hint,m_Comments,m_URL);

	// Were the changes successful?
	if(bRet)
	{
		// Write the entire database.  This allows us to generate a new key on
		// each invocation
		if(!m_Database.Save())
			AfxMessageBox(IDS_SAVE_ERROR,MB_ICONWARNING|MB_OK);

		// Clear the dirty flag
		GetDlgItem(IDC_SAVE)->EnableWindow(FALSE);
		GetDlgItem(IDC_CANCEL)->EnableWindow(FALSE);

		m_Database.FillList(m_Description);

		if(bReselect)
			m_Description.SelectString(-1,strDescription);

		m_strOrigDescription = strDescription;

		m_bIsNew = FALSE;
		m_bDirty = FALSE;
	}
	else if(!m_bIsNew)
	{
		m_Description.SetWindowText(m_strOrigDescription);
	}

	return(bRet);
}

// Prompts user to save the current entry
int CPPDlg::SavePrompt()
{
	int nRet = IDNO;

	// Was the entry modifed?
	if(m_bDirty)
	{
		// Yep...find out what to do with it
		nRet = AfxMessageBox(IDS_SAVE_ENTRY,MB_ICONQUESTION|MB_YESNOCANCEL);

		// User wants to save the entry?
		if(nRet == IDYES)
		{
			// Yep...save it
			BOOL bRet = Save(FALSE);

			// Ooops...bad entry, get out
			if(!bRet)
				return(IDCANCEL);
		}
	}

	return(nRet);
}

// Handles the Cancel button to reload the current entry
void CPPDlg::OnCancelBtn() 
{
	EnableFields(!m_bIsNew);
	LoadFields(m_bIsNew);

	GetDlgItem(IDC_SAVE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CANCEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_DELETE)->EnableWindow(!m_bIsNew);

	m_bIsNew = FALSE;
	m_bDirty = FALSE;
}

// Deletes the current entry
void CPPDlg::OnDelete() 
{
	if(AfxMessageBox(IDS_DELETE_ENTRY,MB_ICONQUESTION|MB_YESNO) == IDYES)
	{
		if(m_Database.Remove(m_strOrigDescription))
		{
			m_Database.Save();

			int nSel = m_Description.GetCurSel();
			m_Description.DeleteString(nSel);

			EnableFields(FALSE);
			LoadFields(TRUE);

			GetDlgItem(IDC_SAVE)->EnableWindow(FALSE);
			GetDlgItem(IDC_CANCEL)->EnableWindow(FALSE);
			GetDlgItem(IDC_DELETE)->EnableWindow(FALSE);

			m_strOrigDescription.Empty();

			m_bDirty = FALSE;
		}
	}
}

// Handles description change message for combobox
void CPPDlg::OnSelendOkDescription() 
{
	CString strText;
	int nSel = m_Description.GetCurSel();

	m_Description.GetLBText(nSel,strText);

	if(SavePrompt() == IDCANCEL)
	{
		PostMessage(UM_RESET);
		return;
	}

	// Save the new description selection
	m_strOrigDescription = strText;
	m_pCurrentEntry = m_Database.Find(strText);

	if(m_pCurrentEntry)
		LoadFields();

	GetDlgItem(IDC_SAVE)->EnableWindow(FALSE);
	GetDlgItem(IDC_CANCEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_DELETE)->EnableWindow(TRUE);

	m_bIsNew = FALSE;
	m_bDirty = FALSE;

	EnableFields(TRUE);

	PostMessage(UM_RESET);
}

// DO NOT REMOVE:  This routine is here to prevent the ENTER key from having the
// default action of exiting the dialog
void CPPDlg::OnOK()
{
}

// Enables or disables screen fields
void CPPDlg::EnableFields(BOOL bEnable)
{
	GetDlgItem(IDC_PASSGEN)->EnableWindow(bEnable);
	GetDlgItem(IDC_PASSWORD)->EnableWindow(bEnable);
	GetDlgItem(IDC_COMMENTS)->EnableWindow(bEnable);
	GetDlgItem(IDC_HINT)->EnableWindow(bEnable);
	GetDlgItem(IDC_URL)->EnableWindow(bEnable);
	GetDlgItem(IDC_USERNAME)->EnableWindow(bEnable);

	bEnable = bEnable && (m_URL.GetLength() > 0);
	GetDlgItem(IDC_LAUNCH)->EnableWindow(bEnable);
}

// Loads an entry's fields from the current data record
void CPPDlg::LoadFields(BOOL bInit)
{
	if(bInit)
	{
		m_Description.SetWindowText("");
		m_Password.SetWindowText("");
		m_UserName = "";
		m_Hint = "";
		m_URL = "";
		m_Comments = "";
	}
	else
	{
		m_Description.SetWindowText((char *) m_pCurrentEntry->m_abyDescription.abyData);
		m_Password.SetWindowText((char *) m_pCurrentEntry->m_abyPassword.abyData);
		m_UserName = (char *) m_pCurrentEntry->m_abyUserID.abyData;
		m_Hint = (char *) m_pCurrentEntry->m_abyHint.abyData;
		m_URL = (char *) m_pCurrentEntry->m_abyURL.abyData;
		m_Comments = (char *) m_pCurrentEntry->m_abyComment.abyData;
	}

	UpdateData(FALSE);
}

// Displays help 
void CPPDlg::OnHelpBtn() 
{
	AfxGetApp()->WinHelp(100,HELP_CONTEXT);
}

// Reloads original description
LRESULT CPPDlg::OnReset(WPARAM,LPARAM)
{
	m_Description.SetWindowText(m_strOrigDescription);
	return(0);
}

// Handles cancel operation for dialog
void CPPDlg::OnCancel() 
{
	if(SavePrompt() == IDCANCEL)
		return;
	
	// Save the window location
	CRect rc;
	GetWindowRect(&rc);

	if(!IsZoomed() && !IsIconic())
	{
		AfxGetApp()->WriteProfileInt("Location","X",rc.left);
		AfxGetApp()->WriteProfileInt("Location","Y",rc.top);
	}

	CDialog::OnCancel();
}

// Handles tooltip relay for button tooltips
BOOL CPPDlg::PreTranslateMessage(MSG* pMsg) 
{
	// Let the tooltip have its own messages
	m_ToolTip.RelayEvent(pMsg);	

	return CDialog::PreTranslateMessage(pMsg);
}

// Display the login screen (this also opens the database)
LRESULT CPPDlg::OnLogin(WPARAM,LPARAM)
{
	CPPLogin dlgLogin;

	dlgLogin.SetDatabase(&m_Database);
	if(dlgLogin.DoModal() != IDOK)
		PostMessage(WM_CLOSE);
	else m_Database.FillList(m_Description);

	// Setup for a new entry initially
	OnNew();

	return(0);
}
