/*
	Password Prompter - PC Magazine password utility

	Copyright (c) 1999 Ziff-Davis Publishing Company.  All rights reserved.
	First published in PC Magazine, US Edition  June 8, 1999.

	Written by Steven E. Sipe


	This file defines the main dialog class.
*/

#if !defined(AFX_MAINDLG_H__255E8C06_E167_11D2_861D_00E02918D61A__INCLUDED_)
#define AFX_MAINDLG_H__255E8C06_E167_11D2_861D_00E02918D61A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPPDlg dialog

#define UM_LOGIN	(WM_USER+200)

#include "staredit.h"
#include "database.h"

#define UM_RESET	(WM_USER+100)

class CPPDlg : public CDialog
{
protected:
	CPPDBHeader m_Database;
	CPPDBEntry *m_pCurrentEntry;
	BOOL m_bDirty;
	BOOL m_bIsNew;
	CString m_strOrigDescription;
	CToolTipCtrl m_ToolTip;
	CString m_strFileName;

protected:
	void EnableFields(BOOL bEnable);
	void LoadFields(BOOL bInit=FALSE);
	BOOL Save(BOOL bReselect=TRUE);
	int SavePrompt();

// Construction
public:
	CPPDlg(CWnd* pParent = NULL);	// standard constructor

public:
	void SetFileName(LPCTSTR lpszFileName) { m_strFileName = lpszFileName; }

// Dialog Data
	//{{AFX_DATA(CPPDlg)
	enum { IDD = IDD_PASSPROM_DIALOG };
	CComboBox	m_Description;
	CButton	m_PassGen;
	CStarEdit m_Password;
	CButton	m_Launch;
	CStatic	m_Write;
	CStatic	m_Lock;
	CStatic	m_Card;
	CString	m_Comments;
	CString	m_Hint;
	CString	m_URL;
	CString	m_UserName;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPPDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CPPDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnLaunch();
	afx_msg void OnPasswordGenerate();
	afx_msg void OnAbout();
	afx_msg void OnNew();
	afx_msg void OnCancelBtn();
	afx_msg void OnSelendOkDescription();
	afx_msg void OnDelete();
	afx_msg void OnHelpBtn();
	afx_msg void OnSave();
	virtual void OnCancel();
	//}}AFX_MSG
	afx_msg void OnChangeFields();
	afx_msg void OnOK();
	afx_msg LRESULT OnReset(WPARAM,LPARAM);
	afx_msg LRESULT OnLogin(WPARAM,LPARAM);

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__255E8C06_E167_11D2_861D_00E02918D61A__INCLUDED_)
