
#ifndef __DATABASE_H__
#define __DATABASE_H__


#include "mangle.h"

// Active key size -- this can be changed, but it should never exceed
// MAX_KEY
#define KEY_SIZE	50

class CPPDBEntry;

typedef struct tagBYTE_ARRAY
{
	BYTE byLen;
	BYTE abyData[255];
} BYTE_ARRAY;

// These should match the maximum password size
#define VALID "aacaaaadaaeabaacyuioqaqqaaaaaertaaajkadaadaaxywqea"

class CPPDBHeader : public CObject
{
protected:
	short m_sFileVersion;
	int m_nEntries;
	int m_nKeySize;
	BYTE_ARRAY m_abyKey;
	BYTE_ARRAY m_abyPassword;
	BYTE_ARRAY m_abyValid;
	CMapStringToOb m_mapIndex;
	CString m_strFileName;
	CString m_strPassword;

protected:
	void Serialize(CArchive &ar);
	void ClearIndex();
	void SetField(BYTE_ARRAY& To, LPCTSTR lpszFrom);

public:
	CPPDBHeader();
	~CPPDBHeader();

public:
	void SetFileName(LPCTSTR lpszFileName) { m_strFileName = lpszFileName; }

	BOOL Save();
	BOOL Load();
	CPPDBEntry *Find(LPCTSTR lpszDescription);

	BOOL Add(LPCTSTR lpszDescription, LPCTSTR lpszUserID, LPCTSTR lpszPassword,
					LPCTSTR lpszHint, LPCTSTR lpszComment, LPCTSTR lpszURL);
	BOOL Modify(LPCTSTR lpszKey,LPCTSTR lpszDescription, LPCTSTR lpszUserID, 
					LPCTSTR lpszPassword, LPCTSTR lpszHint, LPCTSTR lpszComment, 
					LPCTSTR lpszURL);
	BOOL Remove(LPCTSTR lpszDescription);

	void FillList(CComboBox& combo);

	LPCTSTR GetPassword();
	void SetPassword(LPCTSTR lpszPassword, BOOL bSave=TRUE);

	BOOL IsValid() { return memcmp(m_abyValid.abyData,VALID,strlen(VALID)) == 0; }
};

class CPPDBEntry : public CObject
{
public:
	BYTE_ARRAY m_abyDescription;
	BYTE_ARRAY m_abyUserID;
	BYTE_ARRAY m_abyPassword;
	BYTE_ARRAY m_abyHint;
	BYTE_ARRAY m_abyComment;
	BYTE_ARRAY m_abyURL;
	CMangle m_Mangle;

protected:
	void SetKey(BYTE *lpbyKey, int nMaxKey) { m_Mangle.SetKey(lpbyKey,nMaxKey); }
	void Serialize(CArchive &ar);
	void Init();
	void GetField(BYTE_ARRAY& Data, CArchive& ar);
	void PutField(BYTE_ARRAY& Data, CArchive& ar);

public:
	CPPDBEntry();
	~CPPDBEntry();

	friend class CPPDBHeader;
};

#endif
