/*
	Password Prompter - PC Magazine password utility

	Copyright (c) 1999 Ziff-Davis Publishing Company.  All rights reserved.
	First published in PC Magazine, US Edition  June 8, 1999.

	Written by Steven E. Sipe


	This file implements the simple data mangling class.
*/

#include "stdafx.h"
#include <stdlib.h>
#include "mangle.h"

// Performs simple mangling of the specified data buffer.  A password should
// be set before calling this routine (using GenKey())
void CMangle::Encode(LPVOID lpvBuffer, int nLen)
{
	int nKeyIndex = 0, nIndex = 0, nTempLen = nLen;
	BOOL bUp = TRUE;
	BYTE *lpbyTempBuffer = new BYTE[nLen];
	BYTE *lpbyBuffer = (LPBYTE) lpvBuffer;

	while(nTempLen)
	{
		if(nKeyIndex > m_nKeySize-1)
		{
			nKeyIndex = m_nKeySize-1;
			bUp = FALSE;
		}
		else if(nKeyIndex < 0)
		{
			nKeyIndex = 0;
			bUp = TRUE;
		}

		// Save the new data
		lpbyTempBuffer[nIndex] = (lpbyBuffer[nIndex]^m_lpbyKey[nKeyIndex]);

		if(bUp)
			nKeyIndex++;
		else nKeyIndex--;

		nIndex++;
		nTempLen--;
	}

	// Now, replace the original data
	memcpy(lpbyBuffer,lpbyTempBuffer,nLen);
	delete lpbyTempBuffer;
}

// Generates a new random password key
void CMangle::GenKey(BYTE *lpbyKey, int nMaxKey)
{
	srand(GetTickCount());
	for(int x = 0; x < nMaxKey; x++)
		lpbyKey[x] = (rand() % 255);
}
