/*
	Password Prompter - PC Magazine password utility

	Copyright (c) 1999 Ziff-Davis Publishing Company.  All rights reserved.
	First published in PC Magazine, US Edition  June 8, 1999.

	Written by Steven E. Sipe


	This file implements the main application class.
*/

#include "stdafx.h"
#include "passprom.h"
#include "MainDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPApp

BEGIN_MESSAGE_MAP(CPPApp, CWinApp)
	//{{AFX_MSG_MAP(CPPApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPApp construction

CPPApp::CPPApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPPApp object

CPPApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CPPApp initialization

// Determine if Password Prompter is already running by using a Mutex object -- returns
// TRUE if already running, FALSE otherwise.  Note that a mutex is created
// with the name of the application
BOOL CPPApp::AlreadyRunning()
{
	BOOL bFound = FALSE;

	// Try to create a mutex with the app's name
	HANDLE hMutexOneInstance = ::CreateMutex(NULL,TRUE,_T(AfxGetAppName()));

	// Already there...means that we are already running an instance
	if(::GetLastError() == ERROR_ALREADY_EXISTS)
		bFound = TRUE;

	// Release the mutex
	if(hMutexOneInstance)
		::ReleaseMutex(hMutexOneInstance);

	return(bFound);
}

BOOL CPPApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Can't run more than one copy
	if(AlreadyRunning())
	{
		AfxMessageBox(IDS_ALREADY_RUNNING,MB_ICONWARNING|MB_OK);
		return(FALSE);
	}

	// Setup the .ini file to use
	free((void*)m_pszProfileName);
	m_pszProfileName = _tcsdup(_T("passprom.ini"));

	CString strTitle;
	CPPDlg dlg;
	m_pMainWnd = &dlg;

	strTitle.LoadString(IDS_APP_NAME);
	m_pszAppName = strTitle;

	// Set the data file name to use, if specified
	if(__argc > 1)
		dlg.SetFileName(__argv[1]);

	// Display the dialog
	int nResponse = dlg.DoModal();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
